// This is the server

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <sched.h>
#include <errno.h>
#include <string.h>

#include "messip.h"

int
main(int argc, char *argv[])
{
	messip_channel_t *ch;
	int32_t		type  , subtype;
	int		index;
	char rec_buff[256], snd_buff[256];

#if 1
    struct sched_param param;
    if ((param.sched_priority=sched_get_priority_max(SCHED_FIFO)) == -1)
        fprintf (stderr, "sched_get_priority_max(): %s\n", strerror (errno));
    if (( sched_setscheduler(0, SCHED_FIFO, &param)) == -1)
        fprintf (stderr, "sched_setscheduler(): %s\n", strerror (errno));
#endif

	//Create a channel, in order to receive messages on it
	ch = messip_channel_create(NULL, "one", MESSIP_NOTIMEOUT, 0);
	assert(ch != NULL);

	//Receive messages
	for (int i = 0;;i++) {
		index = messip_receive(ch,
				&type, &subtype, rec_buff, sizeof(rec_buff),
				       30000);
		if (index < 0) {
		    switch(index) {
			case MESSIP_MSG_DISCONNECT:
			    printf("MESSIP_MSG_DISCONNECT\n"); break;
			case MESSIP_MSG_DISMISSED:
			    printf("MESSIP_MSG_DISMISSED\n"); break;
			case MESSIP_MSG_TIMEOUT:
			    printf("MESSIP_MSG_TIMEOUT\n"); break;
			case MESSIP_MSG_TIMER:
			    printf("MESSIP_MSG_TIMER\n"); break;
			case MESSIP_MSG_NOREPLY:
			    printf("MESSIP_MSG_NOREPLY\n"); break;
			case MESSIP_MSG_DEATH_PROCESS:
			    printf("MESSIP_MSG_DEATH_PROCESS\n"); break;
			default:
			    printf("MESSIP_MSG_UNKNOWN %d\n", index); break;
		    }
		}

		//30 seconds timeout
		if (index == MESSIP_MSG_TIMEOUT)
			break;
		//printf("<- %s\n", rec_buff);
		//printf("%d/%d\n", type, subtype);
		sprintf(snd_buff, "%d", 100+i);
		messip_reply(ch, index, 0, (void *) snd_buff, strlen(snd_buff)+1, MESSIP_NOTIMEOUT);
		//messip_reply(ch, index, 0, (void *) NULL, 0, MESSIP_NOTIMEOUT);
	}

	return 0;
}
